<?php
if (!defined('FORUM_ROOT'))
	define('FORUM_ROOT', './../../');

require FORUM_ROOT.'include/common.php';

if (!isset($lang_topic_preview)) {
    if (file_exists(FORUM_ROOT.'extensions/topic_preview/lang/'.$forum_user['language'].'/topic_preview.php') )
	    require FORUM_ROOT.'extensions/topic_preview/lang/'.$forum_user['language'].'/topic_preview.php';
    else
	    require FORUM_ROOT.'extensions/topic_preview/lang/English/topic_preview.php';
}

($hook = get_hook('topic_preview_start')) ? eval($hook) : null;

$action = isset($_GET['action']) ? $_GET['action'] : null;

if ($action == 'get_preview')
{
	$topic_id = isset($_GET['topic_id']) ? intval($_GET['topic_id']) : 0;
	$win_width = isset($_GET['win_width']) ? intval($_GET['win_width']) : 0;

	if ($topic_id > 0) 
	{
        $query = array(
			'SELECT'	=> 't.first_post_id, t.moved_to',
			'FROM'		=> 'topics AS t',
            'WHERE'		=> 't.id='.$topic_id
		);

		if ($forum_user['topic_preview_display_options'] == '1')
            $query['SELECT'] .= ', t.last_post_id';
		
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	    $cur_topic = $forum_db->fetch_assoc($result);
		
		if ($cur_topic['moved_to'] == null)
		{
			$topic = $cur_topic;
		}
		else
		{
			$query3 = array(
			    'SELECT'	=> 't.first_post_id, t.moved_to',
			    'FROM'		=> 'topics AS t',
                'WHERE'		=> 't.id='.$cur_topic['moved_to']
		    );
			
			if ($forum_user['topic_preview_display_options'] == '1')
                $query3['SELECT'] .= ', t.last_post_id';
			
		    $result3 = $forum_db->query_build($query3) or error(__FILE__, __LINE__);
	        $topic = $forum_db->fetch_assoc($result3);
		}
		
		($hook = get_hook('topic_preview_get_topic_info')) ? eval($hook) : null;
	
		$query1 = array(
			'SELECT'	=> 'p.id AS pid, p.poster, p.message, p.posted, u.id, u.group_id, u.username, u.avatar',
			'FROM'		=> 'posts AS p',
		    'JOINS'		=> array(
			    array(
				    'LEFT JOIN'	=> 'users AS u',
				    'ON'		=> 'u.id=p.poster_id'
			    ),
		    ),
		);

		if ($forum_user['topic_preview_display_options'] == '0')
            $query1['WHERE'] = 'p.id='.$topic['first_post_id'];
		else
			$query1['WHERE'] = 'p.id IN ('.$topic['first_post_id'].','.$topic['last_post_id'].')';	

		($hook = get_hook('topic_preview_query_get_posts_info')) ? eval($hook) : null;
		$result1 = $forum_db->query_build($query1) or error(__FILE__, __LINE__);
		if ($forum_db->num_rows($result1) > 0) 
		{
		    $no_avatar = '<img src="'.$base_url.'/extensions/topic_preview/css/default.png" alt="No avatar" width="100" height="100">';
			$data = array();
            while ($poster = $forum_db->fetch_assoc($result1)) 
			{
				if ($poster['pid'] == $topic['first_post_id']) {
					$separator = '';
					$post_url = forum_link($forum_url['post'], $topic['first_post_id']);
					$post_title = $lang_topic_preview['First post'];
				} else {
					if ($forum_user['topic_preview_display_options'] == '1') {
					    $separator = '<div class="last-post"></div>';
					    $post_url = forum_link($forum_url['post'], $topic['last_post_id']);
					    $post_title = $lang_topic_preview['Last post'];
					}
				}
				
				$pp_class = '';
				$info_msg = '';
		
		        if ($poster['id'] > 1) {
					$username = (file_exists(FORUM_CACHE_DIR.'cache_pun_coloured_usergroups.php')) ? '<span class="group_color_'.$poster['group_id'].'">'.forum_htmlencode($poster['username']).'</span>' : '<span>'.forum_htmlencode($poster['username']).'</span>';
				
				    if ($forum_config['o_avatars'] == '1' && $forum_user['show_avatars'] != '0') {
			            $u_avatar = generate_avatar_markup($poster['id'], $poster['avatar'], 100, 100, $poster['username']);
			            if (!empty($u_avatar)) { $user_avatar = $u_avatar; } else { $user_avatar = $no_avatar; }
		            } else {
				        $user_avatar = $no_avatar;
			        }
				} else {
					$username = sprintf($lang_topic_preview['Guest'], $poster['poster']);
					$user_avatar = $no_avatar;
				}            
				
				if (!defined('FORUM_PARSER_LOADED'))
			        require FORUM_ROOT.'include/parser.php';

		        $message = parse_message($poster['message'], 0);
		        $message = strip_tags($message);

                if ($win_width > 0)
				{
					$msg_lenght = $win_width * 0.25;
				} else {
					$msg_lenght = 360;
				}
				
				if(utf8_strlen($message) > $msg_lenght)
                {                                      
                    $message = utf8_substr($message,0,$msg_lenght).'...';
                }
				
				($hook = get_hook('topic_preview_posts_loop_end')) ? eval($hook) : null;

				$data[] = $separator.'<div class="author-ident '.$pp_class.'">
								              <div class="pp_head">
								                  <span class="title">'.$post_title.'</span>
									              <span class="info_msg">'.$info_msg.'</span>
								              </div>
					                          <div class="pp_body">
								                  <div class="useravatar">'.$user_avatar.'</div>
									              <div class="pp_message">'.$message.'</div>
								              </div>
											  <div class="pp_footer">
								                  <span class="pp_username">'.$username.'</span>
									              <span class="date">'.format_time($poster['posted']).'</span>
								              </div>
				                          </div>
									  <div class="mup_arrow"></div>';
			}
			
			echo json_encode(array('content'=>$data));
            die;
		}
    }
}
